Scriptname LZBA_boundArmor extends ActiveMagicEffect

Armor Property BoundCuirass Auto
Armor Property BoundBoots Auto
Armor Property BoundGauntlets Auto
Armor Property BoundCrown Auto
MagicEffect Property BoundArmorEffectSelf Auto

Quest Property BoundArmorQuest Auto
String Property BoundCuirassAlias Auto
String Property BoundBootsAlias Auto
String Property BoundGauntletsAlias Auto
String Property BoundCrownAlias Auto

Event OnEffectStart(Actor Target, Actor Caster)
    ;; cuirass
    ObjectReference oRef = Caster.PlaceAtMe(BoundCuirass)
    ReferenceAlias ref = (BoundArmorQuest.GetAliasByName(BoundCuirassAlias) As ReferenceAlias)
    ref.ForceRefTo(oRef)

    Caster.AddItem(oRef, 1, true)
    Caster.EquipItem(oRef.GetBaseObject(), false, true)

    ;; boots
    oRef = Caster.PlaceAtMe(BoundBoots)
    ref = (BoundArmorQuest.GetAliasByName(BoundBootsAlias) As ReferenceAlias)
    ref.ForceRefTo(oRef)

    Caster.AddItem(oRef, 1, true)
    Caster.EquipItem(oRef.GetBaseObject(), false, true)

    ;; gauntlets
    oRef = Caster.PlaceAtMe(BoundGauntlets)
    ref = (BoundArmorQuest.GetAliasByName(BoundGauntletsAlias) As ReferenceAlias)
    ref.ForceRefTo(oRef)

    Caster.AddItem(oRef, 1, true)
    Caster.EquipItem(oRef.GetBaseObject(), false, true)

    ;; crown
    oRef = Caster.PlaceAtMe(BoundCrown)
    ref = (BoundArmorQuest.GetAliasByName(BoundCrownAlias) As ReferenceAlias)
    ref.ForceRefTo(oRef)

    Caster.AddItem(oRef, 1, true)
    Caster.EquipItem(oRef.GetBaseObject(), false, true)
EndEvent

Event OnLoad()
    If !(getCasterActor().hasMagicEffect(BoundArmorEffectSelf))
        Dispel() ; script active, but effect not found on actor
    EndIf
EndEvent

Event OnEffectFinish(Actor Target, Actor Caster)
    ;; cuirass
    ReferenceAlias ref = (BoundArmorQuest.GetAliasByName(BoundCuirassAlias) As ReferenceAlias)
    ref.Clear()

    ;; boots
    ref = (BoundArmorQuest.GetAliasByName(BoundBootsAlias) As ReferenceAlias)
    ref.Clear()

    ;; gauntlets
    ref = (BoundArmorQuest.GetAliasByName(BoundGauntletsAlias) As ReferenceAlias)
    ref.Clear()

    ;; crown
    ref = (BoundArmorQuest.GetAliasByName(BoundCrownAlias) As ReferenceAlias)
    ref.Clear()

    Caster.RemoveItem(BoundCuirass, 1, true)
    Caster.RemoveItem(BoundBoots, 1, true)
    Caster.RemoveItem(BoundGauntlets, 1, true)
    Caster.RemoveItem(BoundCrown, 1, true)
EndEvent
